/****************************************************************************
*  This file is part of the lpc1000 port for the TNKernel RTOS
*
*  Copyright (c) 2009 by Michael Fischer. All rights reserved.
*
*  Redistribution and use in source and binary forms, with or without 
*  modification, are permitted provided that the following conditions 
*  are met:
*  
*  1. Redistributions of source code must retain the above copyright 
*     notice, this list of conditions and the following disclaimer.
*  2. Redistributions in binary form must reproduce the above copyright
*     notice, this list of conditions and the following disclaimer in the 
*     documentation and/or other materials provided with the distribution.
*  3. Neither the name of the author nor the names of its contributors may 
*     be used to endorse or promote products derived from this software 
*     without specific prior written permission.
*
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
*  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
*  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
*  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
*  THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
*  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
*  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS 
*  OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
*  AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
*  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF 
*  THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
*  SUCH DAMAGE.
*
****************************************************************************
*  History:
*
*  26.09.2009  mifi   First Version
****************************************************************************/
#if defined(TN_ARCH_CM3) && defined(TN_PORT_LPC1000)

/*=========================================================================*/
/*  Includes                                                               */
/*=========================================================================*/
#include "tn.h"

/*=========================================================================*/
/*  DEFINE: All Structures and Common Constants                            */
/*=========================================================================*/
typedef void (*IRQ_FUNC)(void);

extern IRQ_FUNC IRQTable[];

/*=========================================================================*/
/*  DEFINE: Definition of all public Data                                  */
/*=========================================================================*/

/*=========================================================================*/
/*  DEFINE: Definition of all local Data                                   */
/*=========================================================================*/

/*=========================================================================*/
/*  DEFINE: Definition of all local Procedures                             */
/*=========================================================================*/

/*=========================================================================*/
/*  DEFINE: All code exported                                              */
/*=========================================================================*/

/***************************************************************************/
/*  xxx_IrqHandler                                                         */
/*                                                                         */
/*  The handler here will be used to jump to user handler                  */
/*  installed by tn_irq_install()                                          */
/*                                                                         */
/*  In    : none                                                           */
/*  Out   : none                                                           */
/*  Return: none                                                           */
/***************************************************************************/

void WDT_IRQHandler (void)
{
   IRQTable[WDT_IRQHandler_ID]();
   tn_int_exit();
}

void TIMER0_IRQHandler (void)
{
   IRQTable[TIMER0_IRQHandler_ID]();
   tn_int_exit();
}

void TIMER1_IRQHandler (void)
{
   IRQTable[TIMER1_IRQHandler_ID]();
   tn_int_exit();
}

void TIMER2_IRQHandler (void)
{
   IRQTable[TIMER2_IRQHandler_ID]();
   tn_int_exit();
}

void TIMER3_IRQHandler (void)
{
   IRQTable[TIMER3_IRQHandler_ID]();
   tn_int_exit();
}

void UART0_IRQHandler (void)
{
   IRQTable[UART0_IRQHandler_ID]();
   tn_int_exit();
}

void UART1_IRQHandler (void)
{
   IRQTable[UART1_IRQHandler_ID]();
   tn_int_exit();
}

void UART2_IRQHandler (void)
{
   IRQTable[UART2_IRQHandler_ID]();
   tn_int_exit();
}

void UART3_IRQHandler (void)
{
   IRQTable[UART3_IRQHandler_ID]();
   tn_int_exit();
}

void PWM1_IRQHandler (void)
{
   IRQTable[PWM1_IRQHandler_ID]();
   tn_int_exit();
}

void I2C0_IRQHandler (void)
{
   IRQTable[I2C0_IRQHandler_ID]();
   tn_int_exit();
}

void I2C1_IRQHandler (void)
{
   IRQTable[I2C1_IRQHandler_ID]();
   tn_int_exit();
}

void I2C2_IRQHandler (void)
{
   IRQTable[I2C2_IRQHandler_ID]();
   tn_int_exit();
}

void SPI_IRQHandler (void)
{
   IRQTable[SPI_IRQHandler_ID]();
   tn_int_exit();
}

void SSP0_IRQHandler (void)
{
   IRQTable[SSP0_IRQHandler_ID]();
   tn_int_exit();
}

void SSP1_IRQHandler (void)
{
   IRQTable[SSP1_IRQHandler_ID]();
   tn_int_exit();
}

void PLL0_IRQHandler (void)
{
   IRQTable[PLL0_IRQHandler_ID]();
   tn_int_exit();
}

void RTC_IRQHandler (void)
{
   IRQTable[RTC_IRQHandler_ID]();
   tn_int_exit();
}

void EINT0_IRQHandler (void)
{
   IRQTable[EINT0_IRQHandler_ID]();
   tn_int_exit();
}

void EINT1_IRQHandler (void)
{
   IRQTable[EINT1_IRQHandler_ID]();
   tn_int_exit();
}

void EINT2_IRQHandler (void)
{
   IRQTable[EINT2_IRQHandler_ID]();
   tn_int_exit();
}

void EINT3_IRQHandler (void)
{
   IRQTable[EINT3_IRQHandler_ID]();
   tn_int_exit();
}

void ADC_IRQHandler (void)
{
   IRQTable[ADC_IRQHandler_ID]();
   tn_int_exit();
}

void BOD_IRQHandler (void)
{
   IRQTable[BOD_IRQHandler_ID]();
   tn_int_exit();
}

void USB_IRQHandler (void)
{
   IRQTable[USB_IRQHandler_ID]();
   tn_int_exit();
}

void CAN_IRQHandler (void)
{
   IRQTable[CAN_IRQHandler_ID]();
   tn_int_exit();
}

void GPDMA_IRQHandler (void)
{
   IRQTable[GPDMA_IRQHandler_ID]();
   tn_int_exit();
}

void I2S_IRQHandler (void)
{
   IRQTable[I2S_IRQHandler_ID]();
   tn_int_exit();
}

void ENET_IRQHandler (void)
{
   IRQTable[ENET_IRQHandler_ID]();
   tn_int_exit();
}

void RIT_IRQHandler (void)
{
   IRQTable[RIT_IRQHandler_ID]();
   tn_int_exit();
}

void MCPWM_IRQHandler (void)
{
   IRQTable[MCPWM_IRQHandler_ID]();
   tn_int_exit();
}

void QEI_IRQHandler (void)
{
   IRQTable[QEI_IRQHandler_ID]();
   tn_int_exit();
}

void PLL1_IRQHandler (void)
{
   IRQTable[PLL1_IRQHandler_ID]();
   tn_int_exit();
}

void USBACT_IRQHandler (void)
{
   IRQTable[USBACT_IRQHandler_ID]();
   tn_int_exit();
}

void CANACT_IRQHandler (void)
{
   IRQTable[CANACT_IRQHandler_ID]();
   tn_int_exit();
}

#endif /* TN_ARCH_CM3 && TN_PORT_LPC1000 */
/*** EOF ***/
